#define  thd_t  (ithd % _NBT)
#define  thd_z  (ithd /(_NBT) % _NBZ)
#define  thd_y  (ithd /(_NBT*_NBZ) % _NBY)
#define  thd_x  (ithd /(_NBT*_NBZ*_NBY) % _NBX)
#define  blk_t  (iblk % _NGT)
#define  blk_z  (iblk /(_NGT) % _NGZ)
#define  blk_y  (iblk /(_NGT*_NGZ) % _NGY)
#define  blk_x  (iblk /(_NGT*_NGZ*_NGY) % _NGX)

static  __device__ __inline__ void
set_sf_boundary_q( float ytr[], float yti[], const int &ithd, const int &iblk, const int *ieo)
{
  int itb    = thd_t + blk_t*_NBT;
  int iz     = thd_z + blk_z*_NBZ;
  int iy     = thd_y + blk_y*_NBY;
  int ix     = thd_x + blk_x*_NBX;
  int ieoxyz = ((*ieo)+(iz+1)+(iy+1)+(ix+1))%2;
  float flag = (float)(1-ieoxyz*((_NTH - itb)/_NTH));
  ytr[ 0] = ytr[ 0] * flag;
  ytr[ 1] = ytr[ 1] * flag;
  ytr[ 2] = ytr[ 2] * flag;
  ytr[ 3] = ytr[ 3] * flag;
  ytr[ 4] = ytr[ 4] * flag;
  ytr[ 5] = ytr[ 5] * flag;
  ytr[ 6] = ytr[ 6] * flag;
  ytr[ 7] = ytr[ 7] * flag;
  ytr[ 8] = ytr[ 8] * flag;
  ytr[ 9] = ytr[ 9] * flag;
  ytr[10] = ytr[10] * flag;
  ytr[11] = ytr[11] * flag;
  yti[ 0] = yti[ 0] * flag;
  yti[ 1] = yti[ 1] * flag;
  yti[ 2] = yti[ 2] * flag;
  yti[ 3] = yti[ 3] * flag;
  yti[ 4] = yti[ 4] * flag;
  yti[ 5] = yti[ 5] * flag;
  yti[ 6] = yti[ 6] * flag;
  yti[ 7] = yti[ 7] * flag;
  yti[ 8] = yti[ 8] * flag;
  yti[ 9] = yti[ 9] * flag;
  yti[10] = yti[10] * flag;
  yti[11] = yti[11] * flag;
}

#undef  thd_t
#undef  thd_z
#undef  thd_y
#undef  thd_x
#undef  blk_t
#undef  blk_z
#undef  blk_y
#undef  blk_x
